Index: LMDZ4/branches/LMDZ4V5.0-dev/libf/phylmd/thermcell_dry.F90
===================================================================
--- LMDZ4/branches/LMDZ4V5.0-dev/libf/phylmd/thermcell_dry.F90	(revision 1292)
+++ LMDZ4/branches/LMDZ4V5.0-dev/libf/phylmd/thermcell_dry.F90	(revision 1294)
@@ -1,2 +1,5 @@
+!
+! $Header$
+!
        SUBROUTINE thermcell_dry(ngrid,nlay,zlev,pphi,ztv,alim_star,  &
      &                            lalim,lmin,zmax,wmax,lev_out)
@@ -4,5 +7,12 @@
 !--------------------------------------------------------------------------
 !thermcell_dry: calcul de zmax et wmax du thermique sec
+! Calcul de la vitesse maximum et de la hauteur maximum pour un panache
+! ascendant avec une fonction d'alimentation alim_star et sans changement 
+! de phase.
+! Le calcul pourrait etre sans doute simplifier.
+! La temperature potentielle virtuelle dans la panache ascendant est
+! la temperature potentielle virtuelle pondÃ©rÃ©e par alim_star.
 !--------------------------------------------------------------------------
+
        IMPLICIT NONE
 #include "YOMCST.h"       
@@ -48,16 +58,4 @@
 !calcul de la vitesse a partir de la CAPE en melangeant thetav
 
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-! A eliminer
-! Ce if complique etait fait pour reperer la premiere couche instable
-! Ici, c'est lmin.
-!
-!       do l=1,nlay-2
-!         do ig=1,ngrid
-!            if (ztv(ig,l).gt.ztv(ig,l+1)  &
-!     &         .and.alim_star(ig,l).gt.1.e-10  &
-!     &         .and.zw2(ig,l).lt.1e-10) then
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
 
 ! Calcul des F^*, integrale verticale de E^*
@@ -84,4 +82,5 @@
 !  Premiere couche du panache thermique
 !------------------------------------------------------------------------
+
                zw2(ig,l+1)=2.*RG*(ztv(ig,l)-ztv(ig,l+1))/ztv(ig,l+1)  &
      &                     *(zlev(ig,l+1)-zlev(ig,l))  &
@@ -96,15 +95,4 @@
 ! 3. la vitesse au carré en haut zw2(ig,l+1)
 !------------------------------------------------------------------------
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!  A eliminer : dans cette version, si zw2 est > 0 on a un therique.
-!  et donc, au dessus, f_star(ig,l+1) est forcement suffisamment 
-!  grand puisque on n'a pas de detrainement.
-!  f_star est une fonction croissante.
-!  c'est donc vraiment sur zw2 uniquement qu'il faut faire le test.
-!           else if ((zw2(ig,l).ge.1e-10).and.  &
-!    &               (f_star(ig,l)+alim_star(ig,l).gt.1.e-10)) then
-!              f_star(ig,l+1)=f_star(ig,l)+alim_star(ig,l)
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
             else if (zw2(ig,l).ge.1e-10) then
@@ -145,21 +133,4 @@
        if (prt_level.ge.1) print*,'fin calcul zw2'
 !
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-! A eliminer :
-! Ce calcul de lmax est fait en meme temps que celui de linter, plus haut
-! Calcul de la couche correspondant a la hauteur du thermique
-!      do ig=1,ngrid
-!         lmax(ig)=lalim(ig)
-!      enddo
-!      do ig=1,ngrid
-!         do l=nlay,lalim(ig)+1,-1
-!            if (zw2(ig,l).le.1.e-10) then
-!               lmax(ig)=l-1
-!            endif
-!         enddo
-!      enddo
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
-!    
 ! Determination de zw2 max
       do ig=1,ngrid
@@ -185,13 +156,4 @@
       do  ig=1,ngrid
 ! calcul de zlevinter
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-! FH A eliminer
-! Simplification
-!          zlevinter(ig)=(zlev(ig,lmax(ig)+1)-zlev(ig,lmax(ig)))*  &
-!     &    linter(ig)+zlev(ig,lmax(ig))-lmax(ig)*(zlev(ig,lmax(ig)+1)  &
-!     &    -zlev(ig,lmax(ig)))
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
           zlevinter(ig)=zlev(ig,lmax(ig)) + &
      &    (linter(ig)-lmax(ig))*(zlev(ig,lmax(ig)+1)-zlev(ig,lmax(ig)))
@@ -199,14 +161,4 @@
       enddo
 
-! Verification que lalim<=lmax
-      do ig=1,ngrid
-         if(lalim(ig)>lmax(ig)) then
-           if ( prt_level > 1 ) THEN
-            print*,'WARNING thermcell_dry ig=',ig,'  lalim=',lalim(ig),'  lmax(ig)=',lmax(ig)
-           endif
-           lmax(ig)=lalim(ig)
-         endif
-      enddo
-      
       RETURN
       END